<?php
namespace FiloBlu\Flow\Block\Adminhtml\Channel\Edit\Tab;
class Config extends \Magento\Backend\Block\Widget\Form\Generic implements \Magento\Backend\Block\Widget\Tab\TabInterface
{
    /**
     * @var \Magento\Store\Model\System\Store
     */
    protected $_systemStore;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Data\FormFactory $formFactory
     * @param \Magento\Store\Model\System\Store $systemStore
     * @param array $data
     */

    public function __construct(
        \FiloBlu\Flow\Helper\Data $helper,
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Data\FormFactory $formFactory,
        \Magento\Store\Model\System\Store $systemStore,
        array $data = array()
    ) {
        $this->_systemStore = $systemStore;

        $this->helper =  $helper;
        parent::__construct($context, $registry, $formFactory, $data);
    }
    /**
     * Prepare form
     *
     * @return $this
     */
    protected function _prepareForm()
    {
        /* @var $model \Magento\Cms\Model\Page */
        $model = $this->_coreRegistry->registry('flow_channel');
        $isElementDisabled = false;
        /** @var \Magento\Framework\Data\Form $form */
        $form = $this->_formFactory->create();

        $form->setHtmlIdPrefix('page_');

        $fieldset_config = $form->addFieldset('config_fieldset', array('legend' => __('Config')));

//        if ($model->getId()) {
//            $fieldset_config->addField('id', 'hidden', array('name' => 'id'));
//        }

//        $fieldset_config->addField("config", "textarea", array(
//            "label" => __("Config Map JSON"),
//            "name" => "config",
//        ));

        $fieldset_config->addField('flow', 'select', array(
                'name' => 'config[flow]',
                'label' => __('Model / Flow'),
                'required' => true,
                'values' => $this->helper->getModels()
            )
        );

        $afterElementHtml = '&nbsp;<small>' . ' Per Flow di tipo Anagrafica: duplicare il file per generare il corrispondente Ite?' . '</small>';
        $copy_to_ite = $fieldset_config->addField('copy_to_ite', 'select', array(
                'name' => 'config[copy_to_ite]',
                'label' => __('Copy to Ite'),
                'required' => false,
                'values' => array('0'=>'No','1'=>'Yes'),
                'default' => 0,
                'after_element_html' => $afterElementHtml
            )
        );

        $ite_channel_name = $fieldset_config->addField('ite_channel_name', 'text', array(
                'name' => 'config[ite_channel_name]',
                'label' => __('Ite channel name'),
                'required' => false
            )
        );

        $fieldset_config->addField("bus", "select", array(
            "label" => __("Bus"),
            "name" => "config[bus]",
            'values' => array('1'=>'1','2' => '2','3'=>'3','4' => '4'),
        ));

        $fieldset_config->addField("priority", "select", array(
            "label" => __("Priority"),
            "name" => "config[priority]",
            'values' => array('high'=>'High','normal'=>'Normal','low' => 'Low'),
        ));

        $fieldset_config->addField("type", "select",array(
            "label" => __("Channel Type"),
            "name" => "config[type]",
            'values' => array('file'=>'File','image'=>'Image','document' => 'Document'),
        ));

        /*{{CedAddFormField}}*/

//        if (!$model->getId()) {
//            $model->setData('status', $isElementDisabled ? '2' : '1');
//        }

//        if (Mage::getSingleton("adminhtml/session")->getChannelData())
//        {
//            $form->setValues(Mage::getSingleton("adminhtml/session")->getChannelData());
//            Mage::getSingleton("adminhtml/session")->setChannelData(null);
//        }
//        elseif(Mage::registry("channel_data")) {
//            $form->setValues(Mage::registry("channel_data")->getData('config'));
//        }

        $form->setValues($model->getData('config'));
        $this->setForm($form);

        return parent::_prepareForm();
    }

    /**
     * Prepare label for tab
     *
     * @return string
     */
    public function getTabLabel()
    {
        return __('Config');
    }

    /**
     * Prepare title for tab
     *
     * @return string
     */
    public function getTabTitle()
    {
        return __('config');
    }

    /**
     * {@inheritdoc}
     */
    public function canShowTab()
    {
        return true;
    }

    /**
     * {@inheritdoc}
     */
    public function isHidden()
    {
        return false;
    }

    /**
     * Check permission for passed action
     *
     * @param string $resourceId
     * @return bool
     */
    protected function _isAllowedAction($resourceId)
    {
        return $this->_authorization->isAllowed($resourceId);
    }

//    public function getTabUrl()
//    {
//        return $this->getUrl('*/*/edit/', ['_current' => true]);
//    }

}
